//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ScktComp.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
#define SSTPsizeLimit 2048


#define CM_MYSENDNEXTMESSAGE	(WM_USER + 20)
#define WM_USERTASKICON			(WM_USER + 21)


const enum eCauseErr{eBadRequest=0,eTimeOut=1,Invisible=3,noErr};

const char sstpStatus[3][20]={
	"400 Bad Request",
	"408 Request Timeout",
	"512 Invisible"};
//SSTP Dispatcherږ߂ꍇ̃Xe[^XR[h

// TServerThred NX
//---------------------------------------------------------------------------
//Server Xbh̃NX TServerClientThread 
//p܂B
class TServerThread : public  TServerClientThread
{
private:
	char sstpBuf[2049];
	int sstpLength;
	bool waitStatus;
	AnsiString reciveAddres;
	TWinSocketStream *pStream;

public:
	__fastcall TServerThread( bool CreateSuspended,
					TServerClientWinSocket* ASocket );

	void __fastcall ClientExecute( void );
	///T[o[ɐڑƂɌĂяo֐
	///T[o[̏̎

	void __fastcall retSSTP(const char *ptr,long size);
	///ptr̓e߂lƂĂrrsoNCAgɑM
	///size͓ẽTCY

	char *getSSTP(){return sstpBuf;};
	///eʂ͑OgetSSTPlengthŊmFĂ
	///sstpBuffeȑꏊԂ

	int __fastcall getSSTPlength(){return sstpLength;};
	///Msstp̃TCY擾

	bool getWaitStatus(){return waitStatus;}
	/// łɑMǂێ

	AnsiString getAddress(){return reciveAddres;}
	///MIPAhX擾
};

class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TButton *Button1;
	TServerSocket *ServerSocket1;
	TButton *Button2;
	TEdit *Edit1;
	TPanel *Panel1;
	TListView *ListView1;
	TSplitter *Splitter1;
	TMainMenu *MainMenu1;
	TMenuItem *File1;
	TMenuItem *Save1;
	TMenuItem *ClearLog1;
	TMenuItem *TaskTray1;
	TMenuItem *AlwaysUseTaskTray1;
	TMenuItem *StartOnTaskTray1;
	TMenuItem *MinimizeToTaskTray1;
	TMenuItem *N1;
	TMenuItem *GoToTaskTray1;

	TPopupMenu *PopupMenuTaskTray1;
	TMenuItem *Open1;
	TMenuItem *N2;
	TMenuItem *Exit1;

	TRichEdit *RichEdit1;
	TSaveDialog *SaveDialog1;

	void __fastcall Button1Click(TObject *Sender);
	void __fastcall ServerSocket1GetThread(TObject *Sender,
			TServerClientWinSocket *ClientSocket,
			TServerClientThread *&SocketThread);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall Edit1KeyPress(TObject *Sender, char &Key);
	void __fastcall AlwaysUseTaskTrayClick(TObject *Sender);
	void __fastcall MinimizeToTaskTrayClick(TObject *Sender);
	void __fastcall GoToTaskTrayClick(TObject *Sender);
	void __fastcall Open1Click(TObject *Sender);
	void __fastcall Exit1Click(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall StartOnTaskTrayClick(TObject *Sender);
	void __fastcall SaveClick(TObject *Sender);
	void __fastcall ClearLogClick(TObject *Sender);
private:	// [U[錾
	struct cSakuraID{
		char *idString;
			//id
		bool update;
			//XVmFp
	};
	struct cSstpList{
	///MSSTP̈ꗗ
		HWND hwnd;
			//M̂WindowHandle
		TServerThread *serverPtr;
			//Mҋ@ĂT[o[Xbh
	};

	NOTIFYICONDATA sdtNotifyIcondata;
		//^XNgCACR`pϐ

	unsigned int s_uTaskbarRestart;
		//^XNgCĕ`vmp

	bool isOnTaskTray;
		//TaskTrayɃACR邩ǂ

	TList *sstpList;
		//MAҋ@ɓĂSSTP̈ꗗ

	char *recevedSSTP;
		//炩̖߂lƂĎMSSTP

	int  ListItemIndexOf(TListItems *Items,char *string);
		///TListItemsItem[]DatacSarkuraIDƂ݂Ȃ
		///vidStringL邩ǂT
		///vidStringꍇ́A̔ԍB
		///ꍇ-1Ԃ

	LPSTR findChar(LPSTR ptri,char code){
		LPSTR ptr=ptri;
		while(*ptr!=NULL){
			if(*ptr==code)
				return ptr;
			ptr++;
		}
		return NULL;
	};

	void updateSakuraList();
		///NĂf̃EBhEnhꗗ擾
		///ListViewo^ĂꗗXV

	void setTaskTrayIcon();
		///^XNgCɃACRo^
	void removeTaskTrayIcon();
		///^XNgCACR폜

	void saveSettings();
		///vOƓfBNginit@C쐬
		///Xe[^Xۑ

	void loadSettings();
		///vOƓfBNgɂinit@C
		///ݒǂݍ

	//bZ[WŎgp֐S
	void sendDirectSSTP(TMessage & mes);
		///DirectSSTP𑗐M
		///PostMessageĂяo
		///TMessage.wParamTServerThread*

	void wmCopyData(TMessage & mes);
		///WM_COPYDATAMB
		///f̃Xe[^XR[hM

	void restartTaskBar(TMessage & mes);
		///TaskBar̍ċNCxgM
		///TaskTrayIcon\Ăo^Cxg𔭍s

	void onTaskTrayIcon(TMessage & msg);
		///TaskTary˂ꂽ

	//bZ[W
	BEGIN_MESSAGE_MAP
		VCL_MESSAGE_HANDLER(CM_MYSENDNEXTMESSAGE,TMessage,sendDirectSSTP)
			//SSTP𑗐M
		VCL_MESSAGE_HANDLER(WM_COPYDATA,TMessage,wmCopyData)
			//WM_COPYDATAMi炩̃Xe[^XԐM)
		VCL_MESSAGE_HANDLER(WM_USERTASKICON, TMessage, onTaskTrayIcon)
			//^XNgC˂ꂽ

		END_MESSAGE_MAP(TComponent)
/*			//{ȂEND_MESSAGE_MAPgp邪
			//ϐMessagedefaultȉ𒼐ڋLq
			//Ⴄo[WC+;Buildergꍇ
			//END_MESSAGE_MAP̃}N̈Ⴂɒӂ邱
		default:
			//^XNo[ēo^v
			if(s_uTaskbarRestart==(((PMessage)Message)->Msg)){
				restartTaskBar(*((TMessage *)Message));
			}
			else
				base::Dispatch(Message);
			break;
	};
*/
public:		// [U[錾

	__fastcall TForm1(TComponent* Owner);
		///ϐȂ

	bool addServerThread (TServerThread *serverPtr,HWND sakuraHWND=NULL );
		///MXbhǉ
		///HWNDɂ͑M̂WindowHandle
		///ȗNULLw莞͎Ō


	void __fastcall TaskTrayMinimize(TObject *Sender);
		///^XNgC̏lŏ

	void __fastcall TaskTrayRestore(TObject *Sender);
		///^XNgC̏l
};

extern TCriticalSection *addLock;
//CtH[RichEditւ̏bN

//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif

